%- Samples -%
trainX = [rand(100,100);-rand(100,100)];
trainy = [ones(100,1);  -ones(100,1)];
testX  = [rand(50,100); -rand(50,100)];
testy  = [rand(50,1);   -ones(50,1)];

%- Initial SVM such as by libsvm-%
gamma = 0.01;
svmmodel = svmtrain(trainy,trainX, sprintf('-s 0 -t 2 -g %f -c 1',gamma));
if svmmodel.Label(1) < 0
	%- Modify the model parameters -%
	svmmodel.rho = -svmmodel.rho;
	svmmodel.sv_coef = -svmmodel.sv_coef;
	svmmodel.Label = flipud(svmmodel.Label);
end

%- Gram matrices -%
gaussKernel = @(x,y) exp(-gamma*(bsxfun(@plus, sum(x.^2,2), sum(y.^2,2)')-2*x*y'));
trainK = gaussKernel(trainX,full(svmmodel.SVs));
testK  = gaussKernel(testX, full(svmmodel.SVs));
svmmodel.K = gaussKernel(full(svmmodel.SVs),full(svmmodel.SVs));

%- SV reduction -%
[rsvmmodel hloss lsloss accs] = ReduceSVs(trainy,trainK,svmmodel,struct('tol',0.025,'eps',0.001),struct('K',testK,'y',testy));
%[rsvmmodel hloss lsloss accs] = ReduceSVs(trainy,trainK,svmmodel,[],struct('K',testK,'y',testy));
%[rsvmmodel hloss lsloss] = ReduceSVs(trainy,trainK,svmmodel,struct('tol',0.025,'eps',0.001));
%[rsvmmodel hloss lsloss] = ReduceSVs(trainy,trainK,svmmodel);

fprintf('%d SVs are reduced into %d SVs !!\n',length(svmmodel.sv_coef),length(rsvmmodel.sv_coef));
